@echo off

:: This script snapshots all volumes that area attached to all EC2 instances in the region
::
:: This script is based on http://sehmer.blogspot.co.nz/2013/02/update-amazon-ec2-daily-snapshot.html
:: by Sehmer.

:: Set login details
set AWS_ACCESS_KEY=xxx
set AWS_SECRET_KEY=xxx

:: Set Region
set EC2_URL=https://ec2.ap-southeast-2.amazonaws.com

:: Java home directory just under the bin for java.exe 
set JAVA_HOME="C:\Program Files\Java\jre7"

:: Path for AWS home directory
set AWS_HOME=C:\AWS

:: Path to EC2 API and subfolder of bin
set EC2_HOME=%AWS_HOME%\ec2-api-tools-1.6.7.3
set PATH=%PATH%;%EC2_HOME%\bin

:: Set today's day of week parameter
for /F "tokens=1 delims=/ " %%a in ('DATE/T') do set dateDOW=%%a


:: First delete all snapshots from this day last week


:: Create a file with all scheduled snapshots
ec2-describe-snapshots|find /i "%dateDOW%: Weekly Backup for">%AWS_HOME%\Working\SnapshotsDOW.txt

:: Delete snapshots for older backups
for /F "tokens=2" %%i in (%AWS_HOME%\Working\SnapshotsDOW.txt) do cmd /c ec2-delete-snapshot %%i


:: Now create a snapshot for every attached volume to every instance


:: Create a file with all attached volumes
ec2-describe-volumes|find /i "attached">%AWS_HOME%\Working\ActiveVolumes.txt

:: Create a file with all instances
ec2-describe-instances|find /i "TAG"|find /i "Name">%AWS_HOME%\Working\InstanceNames.txt

:: Create snapshots of all attached volumes
for /F "tokens=2,3" %%d IN (%AWS_HOME%\Working\ActiveVolumes.txt) do for /F "tokens=3,5*" %%a IN (%AWS_HOME%\Working\InstanceNames.txt) do if %%a EQU %%e ec2-create-snapshot %%d -d "%dateDOW%: Weekly Backup for %%b (VolID:%%d InstID:%%e)"